{$R-}
unit VGIEdit;
Interface
uses Graph,Objects,VgiLow,VgiKeys,VGIText,VgiDlg,FileDlg,textdlg;
Const cmFind=241;
      cmReplace = 242;
      cmRepeatSearch = 243;
      cmSave = 244;
      cmSaveAs=245;
      cmLoad = 240;
Type
     PEditor = ^TEditor;
     TEditor = object (TTextViewer)
                CursorPos:TPoint;{⭮⥫ न 
                                  ⭮⥫쭮 ⥪饣 }
                CurChar:Char;{  ஬}
                TextPos:Word;
                LineStart:Word;
                {Methods}
                Procedure Draw;virtual;
                Procedure Select;virtual;
                Procedure Unselect;virtual;
                Procedure ScrollTo(X, Y : integer);virtual;
                {ᮢ뢠 ⮫쪮 ⥪ ப}
                Procedure DrawLine;
                Function Handle(Code:Word):Integer;virtual;
                {뢠  ப  Count ᨬ, 稭  POS
                 ⠭   ப. 稢 Pos}
                Procedure CursorLeft(Count:Integer);
                Procedure CursorRight(Count:Integer);
                {⠢  ᨬ  ⥪饩 樨 }
                Procedure InsertChar(ch:Char);
                {⠢ Count ᨬ  ⥪饩 樨 }
                Procedure Insert(Count:Integer;var Buf);
                {⠢ ப  ⥪饩 樨 }
                Procedure InsertStr(S:String);
                {/ࠥ }
                Procedure DrawCursor(Invert:Boolean);
                {  ᨬ  }
                Procedure DelChar;
                {ࠡ⪠ CR}
                Procedure CarrigeReturn;
                {६頥 砫    }
                Procedure UpdateIndicator;virtual;
               end;


implementation
 Procedure TEditor.Draw;
 begin
  TTextViewer.Draw;
  if Owner^.Current=@Self then
   DrawCursor(True);
 end;
 Procedure TEditor.Select;
 begin
  DrawCursor(True);
 end;
 PRocedure TEditor.Unselect;
 begin
  DrawCursor(False);
 end;
 Function CharStr(Ch:Char;Count:Integer):String;
 var S:String;
 begin
  FillChar(S,SizeOf(S),ch);
  if Count<0 then Count:=0 else
   if Count>255 then count:=255;
  S[0]:=chr(Count);
  CharStr:=S;
 end;
 Procedure TEditor.CursorLeft(Count:Integer);
 var DX:Integer;
 Begin
  DrawCursor(False);
  if CursorPos.X>=Count then Dec(CursorPos.X,Count) else
   begin
    Count:=CursorPos.X;CursorPos.X:=0;
   end;
  Dec(TextPos,Count);
  if CursorPos.X<Delta.X then
  begin
   DX:=CursorPos.X;
   CursorPos.X:=0;
   ScrollTo(DX,Delta.Y)
  end
   else DrawCursor(True);
 end;
 Procedure TEditor.CursorRight(Count:Integer);
 var DX:Integer;
 Begin
  DrawCursor(False);
  if CursorPos.X+Count<255 then Inc(CursorPos.X,Count) else
   begin
    Count:=255-CursorPos.X;CursorPos.X:=255;
   end;
  Skip(Count,TextPos);
  if CursorPos.X>Delta.X +Size.X then
  begin
   DX:=CursorPos.X-(Size.X+Delta.X);
   Dec(CursorPos.X,DX);
   ScrollTo(Delta.X+DX,Delta.Y)
  end
   else DrawCursor(True);
 end;
 Procedure TEditor.InsertChar(ch:Char);
 Var KbdFlags:Byte absolute $40:$17;
 begin
   if Ch=#13 then CarrigeReturn
  else
  begin
  if TextPos-LineStart<CursorPos.X then
  begin
   InsertStr(CharStr(' ',CursorPos.X-(TextPos-LineStart))+ch);
   TextPos:=CursorPos.X+LineStart;
  end
  else if KbdFlags and $80<>0 then  insert(1,ch) else
  begin
   BufPtr^[TextPos]:=ch;
   if TextPos>=TextSize then inc(TextSize)
  end;
  DrawLine;
  if CursorPos.X>=Limit.X then SetLimit(CursorPos.X+1,Limit.Y);
  CursorRight(1);
 end;
 end;
 Procedure TEditor.InsertStr(S:String);
 begin
  insert(Ord(S[0]),S[1]);
 end;
 Procedure TEditor.Insert(Count:Integer;var Buf);
 var B:TTextBuffer absolute  buf;
     i,last:Integer;
 begin
  Last:=TextSize+Count;
  if Last>BufSize then Last:=BufSize;
  For i:=Last Downto TextPos+Count do BufPtr^[i]:=BufPtr^[i-Count];
   System.Move(B,BufPtr^[TextPos],Count);
  TextSize:=Last;
 end;
 Procedure TEditor.DrawCursor(Invert:Boolean);
 var ch:Char;
 begin
  if not visible then exit;
  if (TextPos>=TextSize) or (TextPos-LineStart<>CursorPos.X)
    or (BufPtr^[TextPos]=#13) then
   Ch:=' ' else Ch:=BufPtr^[TextPos];
  if Invert then
   SwapColors;
  With Limits do
   MoveTo(A.X+(CursorPos.X-Delta.X)*8,A.Y+(CursorPos.Y-Delta.Y)*FontSize);
   DrawChar(ch);
  if Invert then
   SwapColors;
  UpdateIndicator;
 end;
 Procedure Teditor.DelChar;
 Procedure Delete(Count:Integer);
 begin
  System.Move(BufPtr^[TextPos+Count],BufPtr^[TextPos],TextSize-TextPos-Count);
  Dec(TextSize,Count);
 end;
 begin
  if BufPtr^[TextPos]=#13 then
   begin
    Delete(2);
    SetLimit(Limit.X,Pred(Limit.Y));
    Draw;
   end else
   begin
     Delete(1);
     DrawLine;
     DrawCursor(True);
   end;
  end;
 Procedure TEditor.DrawLine;
 var Pos:Word;
 begin
  Pos:=LineStart;
  Skip(Delta.X,Pos);
  MoveTo(Limits.A.X,Limits.A.Y+(CursorPos.Y-Delta.Y)*FontSize);
  DrawText(GetString(Size.x,Pos));
 end;
 Procedure  TEditor.CarrigeReturn;
 var KbdFlags:Byte absolute $40:$17;
 Const CRLF:Word=$0A0D;
 begin
  DrawCursor(False);
  if (KbdFlags and $80)<>0 then
   begin Insert(2,CrLf);SetLimit(Limit.X,Succ(Limit.Y)) end;
  if CursorPos.Y>=Delta.Y+Size.Y-1 then
  begin
   ScrollTo(0,Delta.Y+1);
   DrawCursor(False);
   CursorPos.X:=0;
   TextPos:=LineStart;
   DrawCursor(True);
  end
  else
  begin
   Skip(255,TextPos);
   inc(TextPos,2);
   CursorPos.X:=0;
   inc(CursorPos.Y);
   LineStart:=TextPos;
   if (CursorPos.X<Delta.X)or(CursorPos.Y>=Delta.Y+Size.Y) then
    ScrollTo(0,Succ(Delta.Y)) else if kbdFlags and $80<>0 then Draw else
   DrawCursor(True);
  end;
 end;
Function TEditor.Handle(Code:Word):Integer;
Procedure CursorUp;
begin
 DrawCursor(False);
 Dec(CursorPos.Y);
 Dec(LineStart,2);
 While (LineStart>0) and (bufPtr^[LineStart]<>#10) do dec(LineStart);
 if LineStart>0 then inc(LineStart);
 TextPos:=LineStart;
 Skip(CursorPos.X,TextPos);
 DrawCursor(True);
end;
Procedure CursorDown;
begin
 DrawCursor(False);
 inc(CursorPos.Y);
 Skip(255,LineStart);
 if LineStart=TextSize then
  begin
   Inc(TextSize);
   BufPtr^[TextSize]:=#13;
   Inc(TextSize);
   BufPtr^[TextSize]:=#10;
   Inc(Limit.Y);
  end;
 Inc(LineStart,2);
 TextPos:=LineStart;
 Skip(CursorPos.X,TextPos);
 DrawCursor(True);
end;
Procedure DeleteLine;
var Pos:Word;LineLen:integer;
begin
 Pos:=LineStart;
 Skip(255,Pos);
 if Pos<>TextSize then inc(Pos,2);
 LineLen:=Pos-LineStart;
 System.Move(BufPtr^[Pos],BufPtr^[LineStart],TextSize-Pos);
 Dec(TextSize,LineLen);
 SetLimit(Limit.X,Pred(Limit.Y));
 Draw;
end;
Procedure WordLeft;
begin
end;
Procedure WordRight;
begin
end;
Procedure DelWord;
begin
end;
begin
 Handle:=cmEventPRocessed;
 case Code of
 kbLeft:CursorLeft(1);
 kbRight:CursorRight(1);
 kbHome:begin
         DrawCursor(False);
         TextPos:=LineStart;
         CursorPos.X:=0;
         if Delta.X<>0 then ScrollTo(0,Delta.Y)
          else DrawCursor(True);
        end;
  kbEnd:Begin
         DrawCursor(False);
         Skip(255,TextPos);
         CursorPos.X:=TextPos-LineStart;
         if CursorPos.X>=Delta.X+Size.X then
          ScrollTo(CursorPos.X-Size.X-1,Delta.Y) else DrawCursor(True);
        end;
 kbUp:if CursorPos.Y>Delta.Y then CursorUp else Handle:=0;
 kbDown:If CursorPos.Y<Delta.Y+Size.Y-1 then CursorDown else Handle:=0;
 kbBackSpace:Begin CursorLeft(1);DelChar end;
 kbDel      :DelChar;
 kbAltY+Ord(^Y):DeleteLine;
 kbCtrlLeft:WordLeft;
 kbCtrlRight:WordRight;
 kbAltT+Ord(^T) :DelWord;
 kbMousePressed..kbMouseMoved+$FF:;
 else
  if (Lo(Code)<>0)and(Hi(Code)<>0) then InsertChar(chr(Lo(Code)))
  else
  Handle:=TTextViewer.Handle(Code);
 end;
end;
Procedure TEditor.UpdateIndicator;
begin
end;
Procedure TEditor.ScrollTo(X,Y:Integer);
var RelPos:Tpoint;
begin
  DrawCursor(False);
  CursorPos.X:=CursorPos.X-Delta.X+X;
  CursorPos.Y:=CursorPos.Y-Delta.Y+Y;
  if CursorPos.Y>Limit.Y then CursorPos.Y:=Limit.Y;
  LineStart:=Y2Abs(CursorPos.Y);
  TextPos:=LineStart;
  Skip(CursorPos.X,TextPos);
  TTextViewer.ScrollTo(X,Y);
  DrawCursor(True);
end;
end.