{$X+,R-}
unit VGIPCX;

interface

uses Graph,Objects,VGILow;
{  VGILow ᯮ ⮫쪮 ࠤ  ६:
   GraphDriver  GraphMode,  ࠭ ,  頥 InitGraph
      ᢮ ࠬ. ᫨   ᯮ짮 
     VGI,      ६  ⨬ 
    ᯮ    맮 InitGraph}
Type TPCXPalette = array [0..15,0..2] of byte;
     TPCXHeader  = Record
       Creator      : Byte;   { ZSoft=10}
       Version      : Byte;   {  PCX
                                0 - 2.5  
                                2 - 2.8  ன
                                3 2.8/3.0  
                                5 - 3.0  ன.}
       Encoding     : Byte;   {1-RLE}
       Bits         : Byte;   {⮢  ᥫ}
       Xmin,
       YMin,
       Xmax,
       YMax         : Integer;{ ⨭}
       HRes,
       VRes         : Integer;{襭}
       Palette      : TPCXPalette;
       VMode        : Byte;   {}
       Planes       : Byte;   {᫮ 梥⮢ ᪮⥩}
       BytesPerLine : Word;   {᫮ ⮢  ப}
       PaletteInfo  : Word;   {ଠ  
                               1 - 梥⭣/୮ 
                               2 ࠤ樨 ண}
       shRes,
       SvRes:Word;{襭 ᪠}
       xtra : array [0..53] of byte;{ࢨ஢}
     end;

TPCXLIBHEADER = record
                  id        : Array[0..9] of Char;
                  Copyright : Array [0..49] of char;
                  version   : Word;
                  pcxLabel  : array[0..39] of char;
                  xtra      : array [0..19] of byte;
                end;

TPCXDirectoryENTRY = record
                       Active   : Boolean;
                       FileName : array[0..12] of char;
                       fileSize : LongInt;
                       date     : Word;
                       Time     : Word;
                       Pack     : Word;
                       note     : array[0..39] of char;
                       xtra     : array[0..19]of char;
                     end;
const
  { 訡}
  pcxOk = 0;
  {  訡 ᮢ  ⥬,  頥 IOResult}
  pcxFileNotFound        = 2;
  pcxPathNotFound        = 3 ;
  pcxTooManyFiles        = 4;
  pcxAccessDenied        = 5;
  pcxReadError           = 100;
  pcxWriteError          = 101;
  {  訡 㭨  VGIPCX}
  pcxInvalidFileFormat   = -1; {    PCX  PCL 䠩}
  pcxFileTooLarge        = -2; {     ࠭}
  pcxIncompatibleDisplay = -3; {  ᮧ  㣮 ᪮ }
  pcxImageNotFound       = -4; {  ⥪ ,  㦭
                                 ⨭  }

  Var PcxError           : Integer; {   楤   訡 }

  const SaveMono : Boolean = false;  { ⠭ True    EGA/VGA
                                       ஬ ⨭,  
                                         CGA  Hercules }
        EnablePcxPalette : Boolean = True;  { ⠭ False, ᫨ 
                                                 }
{***********************  ⫠ 楫 ********************}
{**************** ⥭ 䠩 ***********************************}
     { 楤  뢮 ⨭  ࠭}
     {⮪   樮஢  砫 }
     Procedure ShowPcx(var S:TStream;X,Y:Integer;PutMode:Word);
     {뢠 PCX 䠩,  짮⥫  ᠬ⥫쭮
        ⮪}
     Procedure ShowPcxFile(FileName:String;x,Y:Integer;PutMode:Word);
     {뢠 ⥪  頥 㪠⥫  ⮪. 頥
      nil ᫨ ந諠 訡}
     Function OpenPcxLib(FileName:String):PStream;
     { ⨭  ⥪  . True, ᫨ 室}
     Function FindPcxInLib(Lib:PStream;ImageName:String):Boolean;
     {뢠 ⨭  ⥪,  짮⥫
      ᠬ⥫쭮   ⮪}
     Procedure ShowPcxFromLib(LibName,ImageId:String;x,Y:Integer;PutMode:Word);
{******************  䠩 *******************************}
     { 楤 }
     Procedure WritePCX(var S:TStream;X1,Y1,X2,Y2:Integer);
     {࠭ ⥪騩 ViewPort  䠩   }
     Procedure SaveScreen(FileName:String);

implementation

  type ExtStr= String[4];

var Count:Integer;
    ByteValue:Byte;

  {஢ 稥   䠩 ७,  ᫨  ,
   ⠢ ७  㬮砭 Ext}
  Procedure CheckExtension(var fileName:String;Ext:ExtStr);
    var Start,i:Integer;
  begin
    Start:=Length(FileName)-3;
    if Start<=0 then start:=1;
    For i:=Start to Length(FileName) do
      if FileName[i]='.' then exit;{explicit extension found}
    if Ext[1]<>'.' then Insert('.',Ext,1);{    ਢ ࠡ 
                                            Turbo Professional   ⠢
                                              砫 ७ }
    FileName:=FileName+Ext;
  end;

  Procedure ShowPcxFile(FileName:String;x,Y:Integer;PutMode:Word);
    var S:TBufStream;
  begin
    PcxError:=0;
    CheckExtension(FileName,'.PCX');
    S.Init(FileName,stOpenRead,2048);
    if S.Status<>stOk then
    begin
      PcxError:=S.ErrorInfo;
      S.Done;
      exit;
    end;
    ShowPcx(S,X,Y,PutMode);
    S.Done;
  end;

  function CheckLibSignature(var S:TStream):Boolean;
    const pcxLib:Array[0..5]of Char = 'pcxLib';
    var H:TPCxLibHeader;i:integer;
  begin
    PcxError:=0;
    CheckLibSignature:=False;
    S.Read(H,SizeOf(H));
    if S.Status=stReadError then
      PCXError:=pcxReadError
    else
    begin
      For I:=0 to 5 do
        if pcxLib[i]<>H.Id[i] then
        begin
          PcxError:=pcxInvalidFileFormat;
          exit;
        end;
      CheckLibSignature:=True;
    end;
  end;

  Function OpenPcxLib(FileName:String):PStream;
    var S:PStream;
  begin
    PcxError:=0;
    CheckExtension(FileName,'PCL');
    S:=New(PBufStream,Init(FileName,stOpenRead,2048));
    if S^.Status<>stOk then
      PcxError:=S^.ErrorInfo
    else
      if CheckLibSignature(S^) then
      begin
        OpenPcxLib:=S;
        exit;
      end;
    Dispose(S,Done);
    OpenPcxLib:=nil;
  end;

  Function FindPcxInLib(Lib:PStream;ImageName:String):Boolean;
    var D : TPcxDirectoryEntry;
        i : integer;
        LastComp      : Integer;
        Dot,Different : Boolean;
    const AvailiableLetters : set of char = ['0'..'9','A'..'Z','-','_'];
  begin
    PcxError:=0;
    Dot:=False;
    for i:=1 to length(ImageName) do
    begin
      ImageName[i]:=Upcase(ImageName[i]);
      if ImageName[i]='.' then begin LastComp:=PreD(i);Dot:=True;end;
    end;
    if not Dot then LastComp:=Length(ImageName);
    FindPcxInLib:=False;
    if Lib=nil then Exit;
    Lib^.Seek(0);

    {஢ਬ,   ⮪  㫨}
    {   ⥪  ⠭   Directory Entry}
    if not CheckLibSignature(Lib^) then exit;

    {堫 ᪠஢ 䠩}
    Repeat
      Lib^.Read(D,SizeOf(D));
      if Lib^.Status=stReadError then
      begin
        PcxError:=pcxReadError;
        exit;
      end;
      if D.Active then
      begin
        {ࠢ }
        i:=1;
        While (i<LastComp )and not Different do
        begin
          Different:=ImageName[i]=D.FileName[Pred(i)];
          inc(i);
        end;
        Different:=Different or (D.FileName[Pred(i)] in AvailiableLetters);
        if not Different then
        begin
          FindPcxInLib:=True;
          exit;
        end;
      end;
      Lib^.Seek(Lib^.GetPos+D.FileSize);
    until Lib^.GetPos=Lib^.GetSize;
  end;

  procedure ShowPcxFromLib(LibName, ImageId : String; X, Y : integer;
                           PutMode : Word);
    var S : PStream;
  begin
    S:=OpenPcxLib(LibName);
    if S=nil then exit;
    if not FindPcxInLib(S,ImageId) then
    begin
      if PCXError=0 then PcxError:=pcxImageNotFound;
    end else
     ShowPcx(S^,x,y,PutMode);
    Dispose(S,Done);
  end;

  function Unpack(var S:TStream):byte;far;
    var Tmp : byte;
  begin
    if Count<>0 then dec(Count)
    else
    begin
      S.Read(Tmp,1);
      if tmp and $C0= $C0 then
      begin
        count:=tmp and $3F -1;
        S.Read(ByteValue,1);
      end else
      begin
        Count:=0;
        ByteValue:=tmp;
      end;
    end;
    Unpack:=ByteValue;
  end;

  function GetUnpacked(var S:TStream):Byte;far;
  var Tmp : byte;
  begin
    S.Read(Tmp,1);
    GetUnpacked:=tmp;
  end;

  procedure SetPcxPalette(Pal:TPCXPalette);
    var P : PaletteType;
        i,j,BkCol,CgaPal : integer;
        B,BB             : ShortInt;
    const Mask : array[0..2,1..2] of Byte =
                 (($20,$4),($10,$2),($8,$1));
  begin
    GetDefaultPalette(P);
    Case GraphDriver of
      Ega :
      begin {EGA,VGA,16 colors}
        For i:=0 to P.Size-1 do
        begin
          B:=0;
          for j:=0 to 2 do
          begin
            BB:=Pal[i,j] shr 6;
            if BB and 1>0 then B:=B or mask[j,1];
            if BB and 2>0 then B:=B or mask[j,2]
          end;{j}
          P.Colors[i]:=B;
        end;{i}
        SetAllPalette(P);
      end;{0}
      Vga : For i:=0 to 15 do
             begin
              SetPalette(i,i);
              SetRGBPAlette(i,Pal[i,0] div 4,Pal[i,1]div 4,Pal[i,2] div 4);
             end;
      Cga :
      begin { CGA,4 colors }
        BkCol:=(Pal[0,0] div $10) mod 8;
        CgaPal:=(Pal[1,0] div $20) mod 4;
        SetBkColor(BkCol);
        SetGraphMode(CgaPal);
      end;{2}
    end;{ case }
  end;

  Procedure ShowPcx(var S:TStream;X,Y:Integer;PutMode:Word);
    Type ImageMem=Record
           X,Y : Integer;
           Mem : Array[0..0] of byte
         end;
         PImageMem = ^ImageMem;
    Var Divisor,BytesPerLine,
        ImgSize,PixelsPerLine,jj : Word;
        i,j,L  : Integer;
        PI     : PImageMem;
        GetByte: Function(var S : TStream) : Byte;
        H      : TPCXHeader;
        LastRow: Integer;
        Palette256:Array[0..255,0..2] of byte;
  begin
    PcxError:=0;
    Count:=0;
    S.Read(H,SizeOf(H));
    if S.Status=stReadError then
    begin
      PcxError:=pcxReadError;
      exit
    end;

    if H.Encoding=1 then GetByte:=Unpack
                    else GetByte:=GetUnpacked;

    {஢ઠ ᨨ, न  ..}
    if (H.Creator<>10)or  (H.Version >5) or(H.Version<0)then
    begin
      PcxError:=pcxInvalidFileFormat;
      exit;
    end;

    With H do
    begin
      if (X+XMax-XMin>GetMaxX)or(X<0)or(Y<0) then
      begin
        PcxError:=PcxFileTooLarge;
        exit;
      end;
      PCXError := pcxIncompatibleDisplay;
      Case GraphDriver of
        Ega,Vga,VESA16:
          if (Bits<>1) and (Planes<>4) then exit;
        HercMono :
          if (Bits<>1) and (Planes<>1) then exit;
        Cga:
          if Planes<>1 then exit
          else if not((Bits=1)and(GetMaxColor=1)or(Bits=2)and(GetMaxColor=3)) then exit;
        else
            if not((Bits=8)and(Planes=1)and(GetMaxColor=255)) then exit;
      end;
    end;

    { 訡}
    pcxError:=0;

    if ((H.Version=2) or (H.Version=5)) and EnablePcxPAlette then
      SetPcxPalette(H.Palette);
    {稭 㧪 ⨭}
    Divisor:=8 div H.Bits;
    PixelsPerLine:=H.XMax-H.XMin+1;
    BytesPerLine:=PixelsPerLine div Divisor;
    if PixelsPerLine mod divisor<>0 then inc(BytesPerLine);
    ImgSize:=ImageSize(H.Xmin,0,H.XMax,0);
    GetMem(PI,ImgSize);
    Pi^.X:=PixelsPerLine-1;
    Pi^.Y:=0;
    LastRow:=Y+H.YMax-H.YMin;
    if LastRow>GetMaxY then LastRow:=GetMaxY;
    For L:=Y to LastRow do
    begin
      for j:=H.Planes-1 downto 0 do
      begin
        jj:=J*BytesPerLine;
        For i:=0 to BytesPerLine-1 do
          PI^.Mem[i+jj]:=GetByte(S);
        if BytesPerLine<>H.BytesPerLine then GetByte(S);
      end;
      PutImage(X,L,PI^,PutMode);
    end;
    FreeMem(PI,IMgSize);
    if (H.Bits=8) and (H.Version=5) then
     begin
      S.Read(I,1);
      S.Read(Palette256,SizeOf(Palette256));
      if (S.Status=stOk) then
      begin
       if EnablePCXPalette then
         begin
           For i:=0 to 255 do
             For j:=0 to 2 do
               Palette256[i,j]:=Palette256[i,j] shr 2;
           PI:=@Palette256;
          asm
           Les dx,PI
           MOV CX,256
           Sub bx,bx
           Mov AX,1012H
           Int 10H
          end;
        end;
       end
      else S.Reset;
    end;
  end;

  procedure GetPcxPalette(var P:TPcxPalette);
    var
      pal           : PaletteType;
      i             : integer;
      C,c_          : byte;
      palette_index : integer;
      red_value,
      green_value,
      blue_value    : byte;
  begin
    { ᫨  EGA'譠,   ࠧ 梥  ⠢騥 R,G,B,
      (. TechHelp), ᫨  VGA'譠, 梥 㦥  ࠧ 
      ⠢騥
    }
    {
      ⠢ ஢ SaveMono,  ᫨  FALSE,     ,
       ᫨ TRUE,  ᥬ 4- ⮢ ᪮ ᤥ AND ( OR).
    }
    if SaveMono then
    begin

    end else
    case GraphDriver of
      EGA : begin
        GetPalette(pal);
        for i:=0 to 15 do
        begin
          C :=(pal.Colors[i] and 4) shl 5;      { R }
          c_:=(pal.Colors[i] and 32) shl 1;     { r }
          P[i,0]:=C+c_;

          C :=(pal.Colors[i] and 2) shl 6;      { G }
          c_:=(pal.Colors[i] and 16) shl 2;     { g }
          P[i,1]:=C+c_;

          C :=pal.Colors[i] shl 7;              { B }
          c_:=(pal.Colors[i] and 8) shl 3;      { b }
          P[i,2]:=C+c_;
        end;
      end; { EGA }
      VGA : begin
        GetPalette(pal);
        for i:=1 to 15 do
        begin
          palette_index:=pal.Colors[i];
          asm
            MOV    AH, 10h
            MOV    AL, 15h       { read one color register}
            MOV    BX, palette_index
            INT    10h
            MOV    red_value,   DH
            MOV    green_value, CH
            MOV    blue_value,  CL
          end;
          P[i,0]:=red_value*4;
          P[i,1]:=green_value*4;
          P[i,2]:=blue_value*4;
        end;
      end; { VGA }
    end; { case }
  end;

  procedure WritePCX(var S:TStream;X1,Y1,X2,Y2:Integer);
    type TImage=Record
           X,Y      : integer;
           Data     : array[0..319] of byte;
           CheckSum : integer;
         end;
    var
      i,j,k,Bytes : integer;
      Img         : ^TImage;
      H           : TPcxHeader;
      OldByte     : integer;
      Count       : integer;
      Palette     : array[0..255,0..2] of byte;
      P           :Pointer;
    procedure WriteHeader;
    begin
      FillChar(H,SizeOF(H),#0);
      H.Creator:=10;
      H.Version:=2;{Version 2.8  ன}
      H.Encoding:=1;{RLE}
      H.PaletteInfo:=1;
      case GraphDriver of
        CGA,HercMono:
          if (GraphMode = cgaHi) or (GraphDriver=HercMono) then
          begin
            H.Bits:=1;
            H.Planes:=1;
            H.BytesPerLine:=(X2-X1) div 8 + 1;
          end else
          begin
            H.Bits:=2;
            H.Planes:=1;
            H.BytesPerLine:=(X2-X1) div 4 +1;
          end;
        Ega,Vga,vesa16:
        begin
          H.Bits:=1;
          H.BytesPerLine:=(X2-X1) div 8 +1;
          if GetMaxColor=4 then H.Planes:=2 else H.Planes:=4;
        end;
        else
          H.Bits:=8;
          H.Planes:=1;
          H.Version:=5;
          H.BytesPerLine:=X2-X1+1;
      end; { case }
      H.HRes:=Succ(GetMaxX);
      H.VRes:=Succ(GetMaxY);
      GetPcxPalette(H.Palette);
      H.XMin:=0;
      H.XMax:=X2-X1;
      H.Ymin:=0;
      H.YMax:=Y2-Y1;
      S.Write(H,SizeOf(H));
    end;

    Procedure FlushRLE;
    begin
      if OldByte>=0 then
        if (Count=1)and(OldByte<=63) then S.Write(OldByte,1)
        else
        begin
          Count:=Count or $C0;
          S.Write(Count,1);
          S.Write(OldByte,1);
          Count:=1;
          OldByte:=-1;
        end;
    end;

    Procedure PutRLE(B:Byte);
    begin
      if (OldByte=B)and (Count<63) then Inc(Count)
      else
      begin
        FlushRle;
        OldByte:=B;
        Count:=1;
      end;
    end;

  begin     { procedure WritePCX }
    if S.Status<>stOk then
    begin
      PcxError:=pcxWriteError;
      S.Reset;
    end;

    OldByte:=-1;
    Count:=0;
    WriteHeader;
    if S.Status<>stOk then
    begin
      PcxError:=pcxWriteError;
      S.Reset;
    end;

    Getmem(Img,ImageSize(X1,0,X2,0));
    Bytes:=(X2-X1) div (8 div H.bits)+1; {  ᫥   ப }
    for i:=Y1 to Y2 do
    begin
      GetImage(X1,i,X2,I,Img^);
      for j:=H.planes-1 downto 0 do
      begin
        for k:=0 to Bytes-1 do
          PutRLE(Img^.Data[j*Bytes+k]);
        FlushRle;
      end;
      if S.Status<>stOk then
      begin
        PcxError:=PcxWriteError;
        S.Reset;
        Exit
      end;
    end;
   { FlushRle;}
    S.Flush;
    if S.Status<>stOk then
    begin
      PcxError:=PcxWriteError;
      S.Reset;
      exit
    end;
   if GetMaxColor=255 then
    begin
     P:=@Palette;
   asm
   Sub BX,Bx
   Mov CX,256
   Les DX,P
   Mov AX,1017H
   Int 10H
   end;
   For i:=0 to 255 do
    for j:=0 to 2 do
     Palette[i,j]:=Palette[i,j] shl 2;
   i:=12;
   S.Write(I,1);
   S.Write(Palette,SizeOf(Palette));
end;


  end;   { procedure WritePCX }

  procedure SaveScreen(FileName:String);
    var S : TBufStream;
        V : ViewPortType;
  begin
    PcxError:=0;
    CheckExtension(FileName,'.PCX');
    S.Init(FileName,stCreate,2048);
    if S.Status<>stOk then
    begin
      PcxError:=S.ErrorInfo;
      S.Done;
      exit;
    end;

    GetViewSettings(V);
    With V do
    WritePcx(S,X1,Y1,X2,Y2);
    S.Done;
  end;


end.